<template>
  <div id="listDiv">
    <ul>
      <li v-for="p in paginatedData">
        <b-row>
          <b-col cols="11">
            <b>{{p.title | capitalize}}</b>
            <br>
            {{p.body | showExtract}}
          </b-col>
          <b-col cols="1">
            <!--<a href="/modif">-->
            <b-button id="editButton">
              <router-link v-bind:to="{ name: 'modif', params: { id: p.id } }">
                <img src="../assets/edit.png">
              </router-link>
            </b-button>
          </b-col>
        </b-row>
      </li>
    </ul>
    <div id="pagination">
      <b-button :disabled="pageNumber === 1" @click="firstPage" class="paginButton">
        <img src="../assets/double-left-chevron.png">
      </b-button>
      <b-button :disabled="pageNumber === 1" @click="prevPage" class="paginButton">
        <img src="../assets/left-chevron.png">
      </b-button>
      <p id="pageCounter">page {{pageNumber}}/{{pageCount -1}}</p>
      <b-button :disabled="pageNumber >= pageCount -1" @click="nextPage" class="paginButton">
        <img src="../assets/right-chevron.png">
      </b-button>
      <b-button :disabled="pageNumber >= pageCount -1" @click="lastPage" class="paginButton">
        <img src="../assets/double-right-chevron.png">
      </b-button>
    </div>
  </div>
</template>

<script>
export default {
  name: "ArticleList",
  data() {
    return {
      pageNumber: 1
    };
  },
  props: {
    size: {
      type: Number,
      required: false,
      default: 8
    }
  },
  methods: {
    nextPage() {
      this.pageNumber++;
    },
    prevPage() {
      this.pageNumber--;
    },
    firstPage() {
      this.pageNumber = 1;
    },
    lastPage() {
      this.pageNumber = this.pageCount - 1;
    }
  },
  computed: {
    pageCount() {
      let lengthItem = this.$store.state.articles.length;
      let sizeList = this.size;
      return Math.ceil(lengthItem / sizeList);
    },
    paginatedData() {
      let start = "";
      this.pageNumber === 1
        ? (start = 0 * this.size)
        : (start = this.pageNumber * this.size);
      const end = start + this.size;
      return this.$store.getters.articles.slice(start, end);
    }
  },
  filters: {
    showExtract(value) {
      if (value.length > 100) {
        return value.slice(0, 100) + "...";
      } else return value;
    },
    capitalize(value) {
      if (!value) return "";
      value = value.toString();
      return value.toUpperCase();
    }
  }
};
</script>

<style>
#listDiv {
  border: 0px;
}

ul {
  padding: 4px 0px 4px 0px;
  border-bottom: solid;
  margin-bottom: 0px;
}
li {
  list-style-type: none;
  padding: 4px 4px;
  text-align: left;
}
li:hover {
  background-color: #eee;
}
li:nth-child(2n) {
  background-color: #ddd;
}
li:nth-child(2n):hover {
  background-color: #ccc;
}

.paginButton {
  width: 95px;
  height: 40px;
  background-color: #eef;
}

#pagination {
  display: flex;
  align-content: stretch;
  margin: 20px 0px 20px 0px;
}

#pageCounter {
  margin: auto;
}

#editButton {
  padding: 2px;
  border: none;
}

div.col-1 {
  padding: 0px;
}
</style>
